import dotenv from 'dotenv';
import jwt from 'jsonwebtoken';

import UserService from '../services/user.js';

dotenv.config({path: ".env"});

const userDoesNotExist = async (req, res, next) => {

    const { username } = req.body;

    if (await UserService.exists(username)) {
        return res.status(401).send("Such user exists!");
    }
    next();
};

const userExist = async (req, res, next) => {
    let username;
    if (req.body.username) {
        username = req.body.username;
    } else if (req.session.jwt) {
        if (!req.session.jwt || !jwt.verify(req.session.jwt, process.env.SECRET)) {
            return res.status(403).send("Unauthorized");
        }
        username = jwt.decode(req.session.jwt).username;
    }

    if (!(await UserService.exists(username))) {
        return res.status(401).send("Such user does not exists!");
    }
    next();
}

export default {userDoesNotExist, userExist};